<?php
  #######################################################
  # Server Side BackUp © Alessandro Marinuzzi [Alecos]  #
  # Server Side BackUp ••• Version 2.3.00 • 23/03/2023  #
  # Web: https://www.alecos.it • Mail: alecos@alecos.it #
  #######################################################
  @ini_set('default_charset', 'UTF-8');
  if (file_exists(basename("zone-format.php"))) {
    include(basename("zone-format.php"));
  }
  $accessdb = $_SERVER['DOCUMENT_ROOT'] . dirname($_SERVER['PHP_SELF']) . "/log/access_" . date("Y") . ".sqlite";
  $referer = (isset($_SERVER['HTTP_REFERER']) && !empty($_SERVER['HTTP_REFERER'])) ? $_SERVER['HTTP_REFERER'] : 'HTTP_REFERER_UNKNOWN';
  $allowed = 'http';
  if (strcasecmp(substr($referer, 0, strlen($allowed)), $allowed) == 0) {
    $referer = htmlspecialchars($referer, ENT_QUOTES | ENT_HTML401, 'UTF-8');
  } else {
    $referer = 'HTTP_REFERER_UNKNOWN';
  }
  $date = date("Y-m-d H:i:s", $_SERVER['REQUEST_TIME']);
  $ip = $_SERVER['REMOTE_ADDR'];
  $page = basename($_SERVER['REQUEST_URI']);
  if (!isset($page) || empty($page)) {
    $page = basename($_SERVER['SCRIPT_FILENAME']);
  }
  $page = htmlspecialchars($page, ENT_QUOTES | ENT_HTML401, 'UTF-8');
  $agent = (isset($_SERVER['HTTP_USER_AGENT']) && !empty($_SERVER['HTTP_USER_AGENT'])) ? htmlspecialchars($_SERVER['HTTP_USER_AGENT'], ENT_NOQUOTES | ENT_HTML401, 'UTF-8') : 'USER_AGENT_UNKNOWN';
  $referer = str_replace("`", "", $referer);
  $agent = str_replace("`", "", $agent);
  $page = str_replace("`", "", $page);
  try {
    if (!file_exists($accessdb)) {
      $access_log = new PDO("sqlite:" . $accessdb);
      $access_log->exec('CREATE TABLE access(id INTEGER PRIMARY KEY, date DATETIME, ip TEXT, page TEXT, referer TEXT, agent TEXT)');
      
    } else {
      $access_log = new PDO("sqlite:" . $accessdb);
    }
  }
  catch (PDOException $e) {
    die($e->getMessage());
  }
  $insert_accessdb = $access_log->prepare('INSERT INTO access(date, ip, page, referer, agent) VALUES (:date, :ip, :page, :referer, :agent)');
  $insert_accessdb->execute(['date' => $date, 'ip' => $ip, 'page' => $page, 'referer' => $referer, 'agent' => $agent]);
  $access_log = null;
?>