<?php
  #######################################################
  # Server Side BackUp © Alessandro Marinuzzi [Alecos]  #
  # Server Side BackUp ••• Version 2.3.00 • 23/03/2023  #
  # Web: https://www.alecos.it • Mail: alecos@alecos.it #
  #######################################################
  session_start();
  @ini_set('default_charset', 'UTF-8');
  @set_time_limit(0);
  @ini_set('max_execution_time', 0);
  include("access.php");
  $lang = isset($_SERVER['HTTP_ACCEPT_LANGUAGE']) ? substr($_SERVER['HTTP_ACCEPT_LANGUAGE'],0,2) : 'en';
  if (file_exists("./lang/strg_$lang.php")) {
    include("./lang/strg_$lang.php");
  } else {
    include("./lang/strg_en.php");
  }
  $ssbk = "SSBackUp 2.3.00 By Alessandro Marinuzzi [Alecos] © 2015-2023";
  if (isset($_SERVER['REMOTE_USER'])) {
    $auth = $_SERVER['REMOTE_USER'];
  } elseif (isset($_SERVER['PHP_AUTH_USER'])) {
    $auth = $_SERVER['PHP_AUTH_USER'];
  } elseif (isset($_SERVER['REDIRECT_REMOTE_USER'])) {
    $auth = $_SERVER['REDIRECT_REMOTE_USER'];
  } elseif (isset($_SERVER['REDIRECT_PHP_AUTH_USER'])) {
    $auth = $_SERVER['REDIRECT_PHP_AUTH_USER'];
  }
  function check_protocol() {
    $isSecure = false;
    if (isset($_SERVER['HTTPS']) && strtolower($_SERVER['HTTPS']) == 'on') {
      $isSecure = true;
    } elseif (!empty($_SERVER['HTTP_X_FORWARDED_PROTO']) && strtolower($_SERVER['HTTP_X_FORWARDED_PROTO']) == 'https' || !empty($_SERVER['HTTP_X_FORWARDED_SSL']) && strtolower($_SERVER['HTTP_X_FORWARDED_SSL']) == 'on') {
      $isSecure = true;
    }
    return $isSecure;
  }
  if (!isset($auth)) {
    $sdir = $_SERVER['DOCUMENT_ROOT'] . dirname($_SERVER['PHP_SELF']) . "/";
    $backups = glob($sdir . "BackUp*.tar");
    foreach ($backups as $backup) {
      $archive = basename($backup);
      if (file_exists($archive)) {
        $timefile = filemtime($archive);
        $old_file = $archive;
        $new_file = ".$archive";
        rename($old_file, $new_file);
        touch($new_file, $timefile);
      }
    }
    $protocol = check_protocol() ? 'https://' : 'http://';
    $absolute = $protocol . $_SERVER['HTTP_HOST'] . rtrim(dirname($_SERVER['PHP_SELF']), '/\\');
    header("Location: $absolute/welcome.php");
    exit();
  } else {
    $sdir = $_SERVER['DOCUMENT_ROOT'] . dirname($_SERVER['PHP_SELF']) . "/";
    $backups = glob($sdir . ".BackUp*.tar");
    foreach ($backups as $backup) {
      $archive = basename($backup);
      if (file_exists($archive)) {
        $timefile = filemtime($archive);
        $old_file = $archive;
        $new_file = substr($archive, 1);
        rename($old_file, $new_file);
        touch($new_file, $timefile);
      }
    }
  }
?>
<!DOCTYPE html>

<html lang="<?php echo $lang; ?>">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="author" content="Alessandro Marinuzzi [Alecos]">
  <meta name="generator" content="Notepad2">
  <meta name="pragma" content="no-cache">
  <meta name="robots" content="noindex, nofollow">
  <title>SSBackUp &bull; Server Side BackUp</title>
  <link rel="stylesheet" type="text/css" href="css/backup.css">
  <script>
  function SubmitForm() {
    StartProgress();
    StartInfo();
    execute = document.getElementById("execute");
    execute.submit();
  }
  function StartProgress() {
    ProgressImage = document.getElementById('progress_image');
    document.getElementById("progress").style.display = "block";
    setTimeout("ProgressImage.src = ProgressImage.src", 100);
    return true;
  }
  function StartInfo() {
    document.getElementById("info").style.display = "inline-block";
    return true;
  }
  </script>
</head>

<body>

<div class="mainbox">
  <div class="box1">
    <a class="link tooltip" href="exclude.php"><span class="tip"><?php echo $strg_01; ?></span><?php echo $strg_02; ?></a> :: <a class="link tooltip" href="test.php"><span class="tip"><?php echo $strg_03; ?></span><?php echo $strg_04; ?></a> :: <a class="link tooltip" href="settings.php"><span class="tip"><?php echo $strg_05; ?></span><?php echo $strg_06; ?></a> :: <a class="link tooltip" href="#popup1"><span class="tip"><?php echo $strg_07; ?></span><?php echo $strg_08; ?></a><div id="popup1" class="overlay"><div class="popup"><h2><?php echo $strg_08; ?></h2><a class="close" href="#">&times;</a><div class="content"><?php echo $ssbk; ?></div></div></div>
  </div>
  <div class="cleardiv"></div>
  <div class="box1">
    <span class="title"><?php echo $strg_00; ?></span>
  </div>
  <div class="cleardiv"></div>
  <div class="box2">
    <form id="execute" name="execute" action="backup.php" method="post">
    <input class="backup" type="submit" id="backup" name="backup" onclick="SubmitForm()" value="BackUp">
    </form>
  </div>
  <div class="cleardiv"></div>
  <div style="display: none" id="progress"><img id="progress_image" src="css/busy.gif" alt="BackUp in progress..."></div>
  <div class="cleardiv"></div>
  <div class="box3">
<?php
  $url = $_SERVER['QUERY_STRING'];
  $out = array();
  parse_str($url, $out);
  if (isset($out['delete']) || (!empty($out['delete']))) {
    $delete = $out['delete'];
  }
  if (!defined('PHP_EOL')) {
    if (strtoupper(substr(PHP_OS,0,3) == 'WIN')) {
      define('PHP_EOL',"\r\n");
    } elseif (strtoupper(substr(PHP_OS,0,3) == 'MAC')) {
      define('PHP_EOL',"\r");
    } elseif (strtoupper(substr(PHP_OS,0,3) == 'DAR')) {
      define('PHP_EOL',"\n");
    } else {
      define('PHP_EOL',"\n");
    }
  }
  function GetRealSize($file) {
    $size = filesize($file);
    if ($size < 1024) {
      return $size . ' Byte';
    } elseif ($size < 1048576) {
      return number_format(round($size / 1024, 2), 2) . ' KB';
    } elseif ($size < 1073741824) {
      return number_format(round($size / 1048576, 2), 2) . ' MB';
    } elseif ($size < 1099511627776) {
      return number_format(round($size / 1073741824, 2), 2) . ' GB';
    } elseif ($size < 1125899906842624) {
      return number_format(round($size / 1099511627776, 2), 2) . ' TB';
    } elseif ($size < 1152921504606846976) {
      return number_format(round($size / 1125899906842624, 2), 2) . ' PB';
    } elseif ($size < 1180591620717411303424) {
      return number_format(round($size / 1152921504606846976, 2), 2) . ' EB';
    } elseif ($size < 1208925819614629174706176) {
      return number_format(round($size / 1180591620717411303424, 2), 2) . ' ZB';
    } else {
      return number_format(round($size / 1208925819614629174706176, 2), 2) . ' YB';
    }
  }
  function TakeBackupTime($seconds) {
    global $strg_09;
    $hours = floor($seconds / 3600);
    $seconds -= $hours * 3600;
    $minutes = floor($seconds / 60);
    $seconds -= $minutes * 60;
    echo "    <span class=\"time\"><span class=\"time-me\">$strg_09 " . sprintf('%02d', $hours) . ':' . sprintf('%02d', $minutes) . ':' . sprintf('%02d', $seconds) . "</span></span><div class=\"cleardiv\"></div>" . PHP_EOL;
  }
  if ((isset($_COOKIE['ini_time'])) && (!empty($_COOKIE['ini_time']))) {
    $ini_time = htmlspecialchars($_COOKIE['ini_time'], ENT_QUOTES | ENT_HTML401, 'UTF-8');
    $end_time = microtime(true);
    $dif_time = $end_time - $ini_time;
  }
  if ((isset($ini_time)) && (!empty($ini_time))) {
    TakeBackupTime($dif_time);
    $cookie_protocol = check_protocol() ? 'https' : 'http';
    if ($cookie_protocol == 'http') {
      setcookie('ini_time', '', ['expires' => 0, 'path' => '', 'domain' => '', 'secure' => false, 'httponly' => true]);
    } else {
      setcookie('ini_time', '', ['expires' => 0, 'path' => '', 'domain' => '', 'secure' => true, 'httponly' => true, 'samesite' => 'Lax']);
    }
    unset($_COOKIE['ini_time']);
    session_destroy();
  }
  if ((isset($delete)) && (!empty($delete))) {
    $delete = htmlspecialchars($delete, ENT_QUOTES | ENT_HTML401, 'UTF-8');
    $delete = str_replace("\0", "", $delete);
    $delete = basename($delete);
    $cktype = array("tar");
    $ckexts = strtolower(substr(strrchr($delete, "."), 1));
    if ((in_array($ckexts, $cktype)) && (file_exists($delete))) {
      @unlink($delete);
      $protocol = check_protocol() ? 'https://' : 'http://';
      $absolute = $protocol . $_SERVER['HTTP_HOST'] . rtrim(dirname($_SERVER['PHP_SELF']), '/\\');
      header("Location: $absolute/index.php");
    }
  }
  echo "    <span style=\"display: none\" id=\"info\" class=\"info\"><span class=\"info-me\">$strg_44</span></span><div class=\"cleardiv\"></div>" . PHP_EOL;
  $sdir = $_SERVER['DOCUMENT_ROOT'] . dirname($_SERVER['PHP_SELF']) . "/";
  $backups = glob($sdir . "BackUp*.tar");
  array_multisort(array_map('filemtime', $backups), SORT_NUMERIC, SORT_DESC, $backups);
  $count_backups = 0;
  if (file_exists("dat/backdata.dat")) {
    $number_of_backups = file_get_contents("dat/backdata.dat");
    $number_of_backups = htmlentities(trim($number_of_backups), ENT_QUOTES | ENT_HTML401, 'UTF-8');
  } else {
    $number_of_backups = 0;
  }
  foreach ($backups as $backup) {
    $archive = basename($backup);
    ++$count_backups;
    if (($count_backups > $number_of_backups) && ($number_of_backups > 0)) {
      unlink($archive);
    } else {
      echo "    <span class=\"download\"><a href=\"$archive\" class=\"download-me tooltip\" onclick=\"return confirm('$strg_10 " . "$archive?');\"><span class=\"tip\">$strg_10 " . "$archive</span>$archive</a></span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span class=\"delete\"><a class=\"delete-me tooltip\" href=\"index.php?delete=$archive\" onclick=\"return confirm('$strg_11 " . "$archive?');\"><span class=\"tip\">$strg_11 " . "$archive</span>$strg_11</a></span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span class=\"filesize\"><span class=\"filesize-me\">" . GetRealSize($archive) . "</span></span><br>" . PHP_EOL;
    }
  }
  if ($count_backups == 0) {
    echo "    <span class=\"warn\">$strg_12</span><br>" . PHP_EOL;
  }
  ?>
  </div>
  <div class="cleardiv"></div>
</div>

</body>

</html>