<?php
  #######################################################
  # Server Side BackUp © Alessandro Marinuzzi [Alecos]  #
  # Server Side BackUp ••• Version 2.3.00 • 23/03/2023  #
  # Web: https://www.alecos.it • Mail: alecos@alecos.it #
  #######################################################
  @ini_set('default_charset', 'UTF-8');
  include("access.php");
  $lang = isset($_SERVER['HTTP_ACCEPT_LANGUAGE']) ? substr($_SERVER['HTTP_ACCEPT_LANGUAGE'],0,2) : 'en';
  if (file_exists("./lang/strg_$lang.php")) {
    include("./lang/strg_$lang.php");
  } else {
    include("./lang/strg_en.php");
  }
  if (isset($_SERVER['REMOTE_USER'])) {
    $auth = $_SERVER['REMOTE_USER'];
  } elseif (isset($_SERVER['PHP_AUTH_USER'])) {
    $auth = $_SERVER['PHP_AUTH_USER'];
  } elseif (isset($_SERVER['REDIRECT_REMOTE_USER'])) {
    $auth = $_SERVER['REDIRECT_REMOTE_USER'];
  } elseif (isset($_SERVER['REDIRECT_PHP_AUTH_USER'])) {
    $auth = $_SERVER['REDIRECT_PHP_AUTH_USER'];
  }
  function check_protocol() {
    $isSecure = false;
    if (isset($_SERVER['HTTPS']) && strtolower($_SERVER['HTTPS']) == 'on') {
      $isSecure = true;
    } elseif (!empty($_SERVER['HTTP_X_FORWARDED_PROTO']) && strtolower($_SERVER['HTTP_X_FORWARDED_PROTO']) == 'https' || !empty($_SERVER['HTTP_X_FORWARDED_SSL']) && strtolower($_SERVER['HTTP_X_FORWARDED_SSL']) == 'on') {
      $isSecure = true;
    }
    return $isSecure;
  }
  if (!isset($auth)) {
    $protocol = check_protocol() ? 'https://' : 'http://';
    $absolute = $protocol . $_SERVER['HTTP_HOST'] . rtrim(dirname($_SERVER['PHP_SELF']), '/\\');
    header("Location: $absolute/welcome.php");
    exit();
  } else {
    if (!defined('PHP_EOL')) {
      if (strtoupper(substr(PHP_OS,0,3) == 'WIN')) {
        define('PHP_EOL',"\r\n");
      } elseif (strtoupper(substr(PHP_OS,0,3) == 'MAC')) {
        define('PHP_EOL',"\r");
      } elseif (strtoupper(substr(PHP_OS,0,3) == 'DAR')) {
        define('PHP_EOL',"\n");
      } else {
        define('PHP_EOL',"\n");
      }
    }
?>
<!DOCTYPE html>

<html lang="<?php echo $lang; ?>">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="author" content="Alessandro Marinuzzi [Alecos]">
  <meta name="generator" content="Notepad2">
  <meta name="pragma" content="no-cache">
  <meta name="robots" content="noindex, nofollow">
  <title>SSBackUp &bull; Server Side BackUp</title>
  <link rel="stylesheet" type="text/css" href="css/backup.css">
</head>

<body>

<div class="mainbox">
  <div class="box1">
    <a class="link tooltip" href="index.php"><span class="tip"><?php echo $strg_13; ?></span><?php echo $strg_14; ?></a> :: <a class="link tooltip" href="test.php"><span class="tip"><?php echo $strg_03; ?></span><?php echo $strg_04; ?></a> :: <a class="link tooltip" href="exclude.php"><span class="tip"><?php echo $strg_01; ?></span><?php echo $strg_02; ?></a> :: <a class="link tooltip" href="settings.php"><span class="tip"><?php echo $strg_15; ?></span><?php echo $strg_16; ?></a>
  </div>
  <div class="cleardiv"></div>
  <div class="box1">
    <span class="title"><?php echo $strg_31; ?></span>
  </div>
  <div class="cleardiv"></div>
  <div class="box5">
    <form method="post" action="<?php echo htmlspecialchars($_SERVER['PHP_SELF'], ENT_QUOTES | ENT_HTML401, 'UTF-8'); ?>">
      <label class="date_of_backups"><?php echo $strg_48; ?></label>&nbsp;&nbsp;
      <select class="datezone" name="datezone">
<?php  $pref_date = array("american", "european");
        if (file_exists("dat/datezone.dat")) {
          $temp_date = file_get_contents("dat/datezone.dat");
        } else {
          $temp_date = "Not Set";
        }
        foreach ($pref_date as $tdate) {
          if ($tdate == $temp_date) {
            echo "        <option value=\"$tdate\" selected>" . ucfirst($tdate) . "</option>" . PHP_EOL;
          } else {
            echo "        <option value=\"$tdate\">" . ucfirst($tdate) . "</option>" . PHP_EOL;
          }
        } ?>
      </select>&nbsp;&nbsp;<a class="link" href="#date" onclick="return alert('<?php echo $strg_50; ?>');">&nbsp;?&nbsp;</a><br>
      <input class="savedate" type="submit" name="savedate" value="<?php echo $strg_33; ?>">
    </form>
<?php
    $success_date = FALSE;
    if (!is_dir("dat")) {
      mkdir("dat");
      chmod("dat", 0755);
    }
    if ((isset($_POST['savedate'])) && (isset($_POST['datezone']))) {
      $date_format = 'date-format.php';
      $save_date = 'dat/datezone.dat';
      $datezone = $_POST['datezone'];
      switch ($datezone) {
        case 'american':
          file_put_contents($date_format, '<?php $format = \'[m-d-Y][H-i-s]\'; ?>');
          file_put_contents($save_date, $datezone);
          break;
        case 'european':
          file_put_contents($date_format, '<?php $format = \'[d-m-Y][H-i-s]\'; ?>');
          file_put_contents($save_date, $datezone);
          break;
        default:
      }
      chmod($date_format, 0755);
      chmod($save_date, 0755);
      $success_date = TRUE;
    } elseif (file_exists(basename("date-format.php"))) {
      echo "    <br><span class=\"check_done\">$strg_34</span><br><br>" . PHP_EOL;
    } else {
      echo "    <br><span class=\"check_wait\">$strg_35</span><br><br>" . PHP_EOL;
    }
    if ($success_date == TRUE) {
      echo "    <br><span class=\"check_done\">$strg_36 " . ucfirst($datezone) . "</span><br><br>" . PHP_EOL;
    }
  ?>
  </div>
  <div class="cleardiv"></div>
  <div class="box5">
    <form method="post" action="<?php echo htmlspecialchars($_SERVER['PHP_SELF'], ENT_QUOTES | ENT_HTML401, 'UTF-8'); ?>">
      <label class="zone_of_backups"><?php echo $strg_49; ?></label>&nbsp;&nbsp;
      <select class="timezone" name="timezone">
<?php  if (file_exists("dat/timezone.dat")) {
          $temp_zone = file_get_contents("dat/timezone.dat");
        } else {
          $temp_zone = "Not Set";
        }
        foreach (timezone_identifiers_list() as $tzone) {
          if ($tzone == $temp_zone) {
            echo "        <option value=\"$tzone\" selected>$tzone</option>" . PHP_EOL;
          } else {
            echo "        <option value=\"$tzone\">$tzone</option>" . PHP_EOL;
          }
        } ?>
      </select>&nbsp;&nbsp;<a class="link" href="#zone" onclick="return alert('<?php echo $strg_51; ?>');">&nbsp;?&nbsp;</a><br>
      <input class="savezone" type="submit" name="savezone" value="<?php echo $strg_33; ?>">
    </form>
<?php
    $success_zone = FALSE;
    if (!is_dir("dat")) {
      mkdir("dat");
      chmod("dat", 0755);
    }
    if ((isset($_POST['savezone'])) && (isset($_POST['timezone']))) {
      $zone_format = 'zone-format.php';
      $save_zone = 'dat/timezone.dat';
      $timezone = $_POST['timezone'];
      file_put_contents($zone_format, "<?php date_default_timezone_set('$timezone'); ?>");
      file_put_contents($save_zone, $timezone);
      chmod($zone_format, 0755);
      chmod($save_zone, 0755);
      $success_zone = TRUE;
    } elseif (file_exists(basename("zone-format.php"))) {
      echo "    <br><span class=\"check_done\">$strg_34</span><br><br>" . PHP_EOL;
    } else {
      echo "    <br><span class=\"check_wait\">$strg_35</span><br><br>" . PHP_EOL;
    }
    if ($success_zone == TRUE) {
      echo "    <br><span class=\"check_done\">$strg_37 " . $timezone . "</span><br><br>" . PHP_EOL;
    }
  }
  ?>
  </div>
  <div class="cleardiv"></div>
  <div class="box5">
    <form method="post" action="<?php echo htmlspecialchars($_SERVER['PHP_SELF'], ENT_QUOTES | ENT_HTML401, 'UTF-8'); ?>">
      <label class="number_of_backups" for="number_of_backups"><?php echo $strg_45; ?></label>&nbsp;&nbsp;<input class="input" type="number" name="number_of_backups" id="number_of_backups" step="1" min="0" max="100" value="<?php if (file_exists("dat/backdata.dat")) { $temp_backup = file_get_contents("dat/backdata.dat"); $temp_backup = htmlentities(trim($temp_backup), ENT_QUOTES | ENT_HTML401, 'UTF-8'); echo $temp_backup; } else { echo 0; } ?>">&nbsp;&nbsp;<a class="link" href="#help" onclick="return alert('<?php echo $strg_46; ?>');">&nbsp;?&nbsp;</a><br>
      <input class="valid_backups" type="submit" name="valid_backups" value="<?php echo $strg_33; ?>">
    </form>
<?php
    $success_number_of_backups = FALSE;
    if (!is_dir("dat")) {
      mkdir("dat");
      chmod("dat", 0755);
    }
    if ((isset($_POST['number_of_backups'])) && (isset($_POST['valid_backups']))) {
      $save_backups = 'dat/backdata.dat';
      $number_of_backups = $_POST['number_of_backups'];
      file_put_contents($save_backups, $number_of_backups);
      chmod($save_backups, 0755);
      $success_number_of_backups = TRUE;
    } elseif (file_exists("dat/backdata.dat")) {
      echo "    <br><span class=\"check_done\">$strg_34</span><br><br>" . PHP_EOL;
    } else {
      echo "    <br><span class=\"check_wait\">$strg_35</span><br><br>" . PHP_EOL;
    }
    if ($success_number_of_backups == TRUE) {
      echo "    <br><span class=\"check_done\">$strg_47 " . $number_of_backups . "</span><br><br>" . PHP_EOL;
    }
    ?>
  </div>
</div>

</body>

</html>