<?php
  #######################################################
  # Server Side BackUp © Alessandro Marinuzzi [Alecos]  #
  # Server Side BackUp ••• Version 2.3.00 • 23/03/2023  #
  # Web: https://www.alecos.it • Mail: alecos@alecos.it #
  #######################################################
  @ini_set('default_charset', 'UTF-8');
  include("access.php");
  $lang = isset($_SERVER['HTTP_ACCEPT_LANGUAGE']) ? substr($_SERVER['HTTP_ACCEPT_LANGUAGE'],0,2) : 'en';
  if (file_exists("./lang/strg_$lang.php")) {
    include("./lang/strg_$lang.php");
  } else {
    include("./lang/strg_en.php");
  }
?>
<!DOCTYPE html>

<html lang="<?php echo $lang; ?>">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="author" content="Alessandro Marinuzzi [Alecos]">
  <meta name="generator" content="Notepad2">
  <meta name="pragma" content="no-cache">
  <meta name="robots" content="noindex, nofollow">
  <title>SSBackUp &bull; Server Side BackUp</title>
  <link rel="stylesheet" type="text/css" href="css/backup.css">
</head>

<body>

<div class="mainbox">
  <div class="box1">
    <a class="link tooltip" href="index.php"><span class="tip"><?php echo $strg_13; ?></span><?php echo $strg_14; ?></a> :: <a class="link tooltip" href="exclude.php"><span class="tip"><?php echo $strg_01; ?></span><?php echo $strg_02; ?></a> :: <a class="link tooltip" href="settings.php"><span class="tip"><?php echo $strg_05; ?></span><?php echo $strg_06; ?></a>
  </div>
  <div class="cleardiv"></div>
  <div class="box1">
    <span class="title"><?php echo $strg_28; ?></span>
  </div>
  <div class="cleardiv"></div>
  <div class="box5">
    <span class="verify">Exec:</span>
    <?php
      if (!defined('PHP_EOL')) {
        if (strtoupper(substr(PHP_OS,0,3) == 'WIN')) {
          define('PHP_EOL',"\r\n");
        } elseif (strtoupper(substr(PHP_OS,0,3) == 'MAC')) {
          define('PHP_EOL',"\r");
        } elseif (strtoupper(substr(PHP_OS,0,3) == 'DAR')) {
          define('PHP_EOL',"\n");
        } else {
          define('PHP_EOL',"\n");
        }
      }
      if (function_exists('exec')) {
        if (@exec('echo EXEC') == 'EXEC') {
          echo "<span class=\"passed\">$strg_29</span><br>" . PHP_EOL;
        } else {
          echo "<span class=\"failed\">$strg_30</span><br>" . PHP_EOL;
        }
      } else {
        echo "<span class=\"failed\">$strg_30</span><br>" . PHP_EOL;
      }
    ?>
    <span class="verify">Tar:</span>
    <?php
      $sdir = realpath($_SERVER['DOCUMENT_ROOT'] . dirname($_SERVER['PHP_SELF']));
      if (strtoupper(substr(PHP_OS,0,3) == 'WIN')) {
        $sdir = str_replace("\\", "/", $sdir);
      }
      if (function_exists('exec')) {
        @exec("tar -cf $sdir/test.tar $sdir/test.php ");
        if (file_exists("$sdir/test.tar")) {
          echo "<span class=\"passed\">$strg_29</span><br>" . PHP_EOL;
        } else {
          echo "<span class=\"failed\">$strg_30</span><br>" . PHP_EOL;
        }
      } else {
        echo "<span class=\"failed\">$strg_30</span><br>" . PHP_EOL;
      }
      if (file_exists("$sdir/test.tar")) {
        unlink("$sdir/test.tar");
      }
    ?>
  </div>
  <div class="cleardiv"></div>
</div>

</body>

</html>